Index: src/tesselationhelpers.cpp
===================================================================
--- src/tesselationhelpers.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/tesselationhelpers.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * TesselationHelpers.cpp
@@ -6,20 +13,30 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include <fstream>
 
-#include "info.hpp"
+#include "BoundaryLineSet.hpp"
+#include "BoundaryPointSet.hpp"
+#include "BoundaryPolygonSet.hpp"
+#include "BoundaryTriangleSet.hpp"
+#include "CandidateForTesselation.hpp"
+#include "Helpers/Info.hpp"
 #include "linkedcell.hpp"
-#include "linearsystemofequations.hpp"
-#include "log.hpp"
+#include "LinearAlgebra/linearsystemofequations.hpp"
+#include "Helpers/Log.hpp"
 #include "tesselation.hpp"
 #include "tesselationhelpers.hpp"
-#include "vector.hpp"
-#include "Line.hpp"
-#include "vector_ops.hpp"
-#include "verbose.hpp"
-#include "Plane.hpp"
-#include "Matrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/Line.hpp"
+#include "LinearAlgebra/vector_ops.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Plane.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 
 void GetSphere(Vector * const center, const Vector &a, const Vector &b, const Vector &c, const double RADIUS)
@@ -144,5 +161,5 @@
  * \param *c third point
  */
-void GetCenterofCircumcircle(Vector * const Center, const Vector &a, const Vector &b, const Vector &c)
+void GetCenterofCircumcircle(Vector &Center, const Vector &a, const Vector &b, const Vector &c)
 {
 	Info FunctionInfo(__func__);
@@ -156,10 +173,11 @@
   helper[2] = SideC.NormSquared()*(SideA.NormSquared()+SideB.NormSquared() - SideC.NormSquared());
 
-  Center->Zero();
-  *Center += helper[0] * a;
-  *Center += helper[1] * b;
-  *Center += helper[2] * c;
-  Center->Scale(1./(helper[0]+helper[1]+helper[2]));
-  Log() << Verbose(1) << "INFO: Center (2nd algo) is at " << *Center << "." << endl;
+  Center.Zero();
+  Center += helper[0] * a;
+  Center += helper[1] * b;
+  Center += helper[2] * c;
+  if (fabs(helper[0]+helper[1]+helper[2]) > MYEPSILON)
+    Center.Scale(1./(helper[0]+helper[1]+helper[2]));
+  Log() << Verbose(1) << "INFO: Center (2nd algo) is at " << Center << "." << endl;
 };
 
@@ -175,7 +193,8 @@
  * \param NormalVector normal vector
  * \param SearchDirection search direction to make angle unique on return.
+ * \param HULLEPSILON machine precision for tesselation points
  * \return Angle between \a NewSphereCenter and \a OldSphereCenter relative to \a CircleCenter, 2.*M_PI if one test fails
  */
-double GetPathLengthonCircumCircle(const Vector &CircleCenter, const Vector &CirclePlaneNormal, const double CircleRadius, const Vector &NewSphereCenter, const Vector &OldSphereCenter, const Vector &NormalVector, const Vector &SearchDirection)
+double GetPathLengthonCircumCircle(const Vector &CircleCenter, const Vector &CirclePlaneNormal, const double CircleRadius, const Vector &NewSphereCenter, const Vector &OldSphereCenter, const Vector &NormalVector, const Vector &SearchDirection, const double HULLEPSILON)
 {
 	Info FunctionInfo(__func__);
@@ -388,5 +407,5 @@
  * @return point which is second closest to the provided one
  */
-TesselPoint* FindSecondClosestTesselPoint(const Vector* Point, const LinkedCell* const LC)
+TesselPoint* FindSecondClosestTesselPoint(const Vector& Point, const LinkedCell* const LC)
 {
 	Info FunctionInfo(__func__);
@@ -412,5 +431,5 @@
         if (List != NULL) {
           for (LinkedCell::LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
-            helper = (*Point) - (*(*Runner)->node);
+            helper = (Point) - ((*Runner)->getPosition());
             double currentNorm = helper. Norm();
             if (currentNorm < distance) {
@@ -441,5 +460,5 @@
  * @return point which is closest to the provided one, NULL if none found
  */
-TesselPoint* FindClosestTesselPoint(const Vector* Point, TesselPoint *&SecondPoint, const LinkedCell* const LC)
+TesselPoint* FindClosestTesselPoint(const Vector& Point, TesselPoint *&SecondPoint, const LinkedCell* const LC)
 {
 	Info FunctionInfo(__func__);
@@ -465,5 +484,5 @@
         if (List != NULL) {
           for (LinkedCell::LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
-            helper = (*Point) - (*(*Runner)->node);
+            helper = (Point) - ((*Runner)->getPosition());
             double currentNorm = helper.NormSquared();
             if (currentNorm < distance) {
@@ -503,6 +522,6 @@
 	Info FunctionInfo(__func__);
   // construct the plane of the two baselines (i.e. take both their directional vectors)
-  Vector Baseline = (*Base->endpoints[1]->node->node) - (*Base->endpoints[0]->node->node);
-  Vector OtherBaseline = (*OtherBase->endpoints[1]->node->node) - (*OtherBase->endpoints[0]->node->node);
+  Vector Baseline = (Base->endpoints[1]->node->getPosition()) - (Base->endpoints[0]->node->getPosition());
+  Vector OtherBaseline = (OtherBase->endpoints[1]->node->getPosition()) - (OtherBase->endpoints[0]->node->getPosition());
   Vector Normal = Baseline;
   Normal.VectorProduct(OtherBaseline);
@@ -511,15 +530,15 @@
 
   // project one offset point of OtherBase onto this plane (and add plane offset vector)
-  Vector NewOffset = (*OtherBase->endpoints[0]->node->node) - (*Base->endpoints[0]->node->node);
+  Vector NewOffset = (OtherBase->endpoints[0]->node->getPosition()) - (Base->endpoints[0]->node->getPosition());
   NewOffset.ProjectOntoPlane(Normal);
-  NewOffset += (*Base->endpoints[0]->node->node);
+  NewOffset += (Base->endpoints[0]->node->getPosition());
   Vector NewDirection = NewOffset + OtherBaseline;
 
   // calculate the intersection between this projected baseline and Base
   Vector *Intersection = new Vector;
-  Line line1 = makeLineThrough(*(Base->endpoints[0]->node->node),*(Base->endpoints[1]->node->node));
+  Line line1 = makeLineThrough((Base->endpoints[0]->node->getPosition()),(Base->endpoints[1]->node->getPosition()));
   Line line2 = makeLineThrough(NewOffset, NewDirection);
   *Intersection = line1.getIntersection(line2);
-  Normal = (*Intersection) - (*Base->endpoints[0]->node->node);
+  Normal = (*Intersection) - (Base->endpoints[0]->node->getPosition());
   DoLog(1) && (Log() << Verbose(1) << "Found closest point on " << *Base << " at " << *Intersection << ", factor in line is " << fabs(Normal.ScalarProduct(Baseline)/Baseline.NormSquared()) << "." << endl);
 
@@ -566,5 +585,5 @@
       *vrmlfile << "Sphere {" << endl << "  "; // 2 is sphere type
       for (i=0;i<NDIM;i++)
-        *vrmlfile << Walker->node->at(i)-center->at(i) << " ";
+        *vrmlfile << Walker->at(i)-center->at(i) << " ";
       *vrmlfile << "\t0.1\t1. 1. 1." << endl; // radius 0.05 and white as colour
       cloud->GoToNext();
@@ -576,5 +595,5 @@
       for (i=0;i<3;i++) { // print each node
         for (int j=0;j<NDIM;j++)  // and for each node all NDIM coordinates
-          *vrmlfile << TriangleRunner->second->endpoints[i]->node->node->at(j)-center->at(j) << " ";
+          *vrmlfile << TriangleRunner->second->endpoints[i]->node->at(j)-center->at(j) << " ";
         *vrmlfile << "\t";
       }
@@ -603,7 +622,7 @@
     Vector *center = cloud->GetCenter();
     // make the circumsphere's center absolute again
-    Vector helper = (1./3.) * ((*Tess->LastTriangle->endpoints[0]->node->node) +
-                               (*Tess->LastTriangle->endpoints[1]->node->node) +
-                               (*Tess->LastTriangle->endpoints[2]->node->node));
+    Vector helper = (1./3.) * ((Tess->LastTriangle->endpoints[0]->node->getPosition()) +
+                               (Tess->LastTriangle->endpoints[1]->node->getPosition()) +
+                               (Tess->LastTriangle->endpoints[2]->node->getPosition()));
     helper -= (*center);
     // and add to file plus translucency object
@@ -638,5 +657,5 @@
       *rasterfile << "2" << endl << "  ";  // 2 is sphere type
       for (int j=0;j<NDIM;j++) { // and for each node all NDIM coordinates
-        const double tmp = Walker->node->at(j)-center->at(j);
+        const double tmp = Walker->at(j)-center->at(j);
         *rasterfile << ((fabs(tmp) < MYEPSILON) ? 0 : tmp) << " ";
       }
@@ -651,5 +670,5 @@
       for (i=0;i<3;i++) {  // print each node
         for (int j=0;j<NDIM;j++) { // and for each node all NDIM coordinates
-          const double tmp = TriangleRunner->second->endpoints[i]->node->node->at(j)-center->at(j);
+          const double tmp = TriangleRunner->second->endpoints[i]->node->at(j)-center->at(j);
           *rasterfile << ((fabs(tmp) < MYEPSILON) ? 0 : tmp) << " ";
         }
@@ -705,5 +724,5 @@
       LookupList[Walker->nr] = Counter++;
       for (int i=0;i<NDIM;i++) {
-        const double tmp = Walker->node->at(i);
+        const double tmp = Walker->at(i);
         *tecplot << ((fabs(tmp) < MYEPSILON) ? 0 : tmp) << " ";
       }
@@ -754,5 +773,5 @@
     TriangleSet *triangles = TesselStruct->GetAllTriangles(PointRunner->second);
     for (TriangleSet::iterator TriangleRunner = triangles->begin(); TriangleRunner != triangles->end(); ++TriangleRunner) {
-      totalarea += CalculateAreaofGeneralTriangle(*(*TriangleRunner)->endpoints[0]->node->node, *(*TriangleRunner)->endpoints[1]->node->node, *(*TriangleRunner)->endpoints[2]->node->node);
+      totalarea += CalculateAreaofGeneralTriangle((*TriangleRunner)->endpoints[0]->node->getPosition() , (*TriangleRunner)->endpoints[1]->node->getPosition() , (*TriangleRunner)->endpoints[2]->node->getPosition());
     }
     ConcavityPerLine *= totalarea;
@@ -763,6 +782,6 @@
       line = (*TriangleRunner)->GetThirdLine(PointRunner->second);
       triangle = line->GetOtherTriangle(*TriangleRunner);
-      area = CalculateAreaofGeneralTriangle(*triangle->endpoints[0]->node->node, *triangle->endpoints[1]->node->node, *triangle->endpoints[2]->node->node);
-      area += CalculateAreaofGeneralTriangle(*(*TriangleRunner)->endpoints[0]->node->node, *(*TriangleRunner)->endpoints[1]->node->node, *(*TriangleRunner)->endpoints[2]->node->node);
+      area = CalculateAreaofGeneralTriangle(triangle->endpoints[0]->node->getPosition() , triangle->endpoints[1]->node->getPosition() , triangle->endpoints[2]->node->getPosition());
+      area += CalculateAreaofGeneralTriangle((*TriangleRunner)->endpoints[0]->node->getPosition() , (*TriangleRunner)->endpoints[1]->node->getPosition() , (*TriangleRunner)->endpoints[2]->node->getPosition());
       area *= -line->CalculateConvexity();
       if (area > 0)
@@ -797,5 +816,5 @@
     distance = 0.;
     for (TriangleMap::const_iterator TriangleRunner = Convex->TrianglesOnBoundary.begin(); TriangleRunner != Convex->TrianglesOnBoundary.end(); TriangleRunner++) {
-      const double CurrentDistance = Convex->GetDistanceSquaredToTriangle(*PointRunner->second->node->node, TriangleRunner->second);
+      const double CurrentDistance = Convex->GetDistanceSquaredToTriangle(PointRunner->second->node->getPosition() , TriangleRunner->second);
       if (CurrentDistance < distance)
         distance = CurrentDistance;
Index: src/tesselationhelpers.hpp
===================================================================
--- src/tesselationhelpers.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/tesselationhelpers.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -22,4 +22,5 @@
 #include <iosfwd>
 
+#include "BoundaryMaps.hpp"
 #include "defs.hpp"
 
@@ -29,4 +30,6 @@
 class BoundaryLineSet;
 class BoundaryTriangleSet;
+class BoundaryPolygonSet;
+class CandidateForTesselation;
 class LinkedCell;
 class TesselPoint;
@@ -37,12 +40,10 @@
 /********************************************** definitions *********************************/
 
-#define HULLEPSILON 1e-9 //!< TODO: Get rid of HULLEPSILON, points to numerical instabilities
-
 /********************************************** declarations *******************************/
 
-void GetSphere(Vector * const Center, const Vector &a, const Vector &b, const Vector &c, const double RADIUS);
-void GetCenterOfSphere(Vector* const Center, const Vector &a, const Vector &b, const Vector &c, Vector * const NewUmkreismittelpunkt, const Vector* const Direction, const Vector* const AlternativeDirection, const double HalfplaneIndicator, const double AlternativeIndicator, const double alpha, const double beta, const double gamma, const double RADIUS, const double Umkreisradius);
-void GetCenterofCircumcircle(Vector * const Center, const Vector &a, const Vector &b, const Vector &c);
-double GetPathLengthonCircumCircle(const Vector &CircleCenter, const Vector &CirclePlaneNormal, const double CircleRadius, const Vector &NewSphereCenter, const Vector &OldSphereCenter, const Vector &NormalVector, const Vector &SearchDirection);
+void GetSphere(Vector & Center, const Vector &a, const Vector &b, const Vector &c, const double RADIUS);
+void GetCenterOfSphere(Vector& Center, const Vector &a, const Vector &b, const Vector &c, Vector &NewUmkreismittelpunkt, const Vector &Direction, const Vector* const AlternativeDirection, const double HalfplaneIndicator, const double AlternativeIndicator, const double alpha, const double beta, const double gamma, const double RADIUS, const double Umkreisradius);
+void GetCenterofCircumcircle(Vector & Center, const Vector &a, const Vector &b, const Vector &c);
+double GetPathLengthonCircumCircle(const Vector &CircleCenter, const Vector &CirclePlaneNormal, const double CircleRadius, const Vector &NewSphereCenter, const Vector &OldSphereCenter, const Vector &NormalVector, const Vector &SearchDirection, const double HULLEPSILON);
 double CalculateVolumeofGeneralTetraeder(const Vector &a, const Vector &b, const Vector &c, const Vector &d);
 double CalculateAreaofGeneralTriangle(const Vector &A, const Vector &B, const Vector &C);
@@ -51,6 +52,6 @@
 bool CheckLineCriteriaForDegeneratedTriangle(const BoundaryPointSet * const nodes[3]);
 bool SortCandidates(const CandidateForTesselation* candidate1, const CandidateForTesselation *candidate2);
-TesselPoint* FindClosestTesselPoint(const Vector* Point, TesselPoint *&SecondPoint, const LinkedCell* const LC);
-TesselPoint* FindSecondClosestTesselPoint(const Vector*, const LinkedCell* const LC);
+TesselPoint* FindClosestTesselPoint(const Vector & Point, TesselPoint *&SecondPoint, const LinkedCell* const LC);
+TesselPoint* FindSecondClosestTesselPoint(const Vector &, const LinkedCell* const LC);
 Vector * GetClosestPointBetweenLine(const BoundaryLineSet * const Base, const BoundaryLineSet * const OtherBase);
 
@@ -61,5 +62,5 @@
 void CalculateConcavityPerBoundaryPoint(const Tesselation * const TesselStruct);
 void CalculateConstrictionPerBoundaryPoint(const Tesselation * const TesselStruct, const Tesselation * const Convex);
-double DistanceToTrianglePlane(const Vector *x, const BoundaryTriangleSet * const triangle);
+double DistanceToTrianglePlane(const Vector &x, const BoundaryTriangleSet * const triangle);
 
 bool CheckListOfBaselines(const Tesselation * const TesselStruct);
Index: src/test/ActOnAlltest.hpp
===================================================================
--- src/test/ActOnAlltest.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/test/ActOnAlltest.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -12,5 +12,5 @@
 
 #include <list>
-#include "../vector.hpp"
+#include "../LinearAlgebra/Vector.hpp"
 
 #define ListOfVectors list<Vector *>
Index: src/triangleintersectionlist.cpp
===================================================================
--- src/triangleintersectionlist.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/triangleintersectionlist.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * triangleintersectionlist.cpp
@@ -9,4 +16,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -15,13 +27,17 @@
 #include "triangleintersectionlist.hpp"
 
-#include "info.hpp"
+#include "Helpers/Info.hpp"
+#include "BoundaryMaps.hpp"
+#include "BoundaryPointSet.hpp"
+#include "BoundaryLineSet.hpp"
+#include "BoundaryTriangleSet.hpp"
 #include "tesselation.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Verbose.hpp"
 
 /** Constructor for class TriangleIntersectionList.
  *
  */
-TriangleIntersectionList::TriangleIntersectionList(const Vector *x, const Tesselation *surface, const LinkedCell* LC) :
+TriangleIntersectionList::TriangleIntersectionList(const Vector &x, const Tesselation *surface, const LinkedCell* LC) :
   Point(x),
   Tess(surface),
@@ -70,5 +86,5 @@
   }
   // return reference, if none can be found
-  return *Point;
+  return Point;
 };
 
@@ -99,5 +115,5 @@
   if (runner != IntersectionList.end()) {
     // if we have found one, check Scalarproduct between the vector
-    Vector TestVector = (*Point) - (*(*runner).second);
+    Vector TestVector = (Point) - (*(*runner).second);
     if (fabs(TestVector.NormSquared()) < MYEPSILON) //
       return true;
@@ -138,6 +154,6 @@
     // get intersection with triangle plane
     Intersection = new Vector;
-    (*TriangleRunner)->GetClosestPointInsideTriangle(Point, Intersection);
-    //Log() << Verbose(1) << "Intersection between " << *Point << " and " << **TriangleRunner << " is at " << *Intersection << "." << endl;
+    (*TriangleRunner)->GetClosestPointInsideTriangle(Point, *Intersection);
+    //Log() << Verbose(1) << "Intersection between " << Point << " and " << **TriangleRunner << " is at " << *Intersection << "." << endl;
     IntersectionList.insert( pair<BoundaryTriangleSet *, Vector * > (*TriangleRunner, Intersection) );
   }
@@ -151,5 +167,5 @@
   if (DistanceList.empty())
     for (TriangleVectorMap::const_iterator runner = IntersectionList.begin(); runner != IntersectionList.end(); runner++)
-      DistanceList.insert( pair<double, BoundaryTriangleSet *> (Point->distance(*(*runner).second), (*runner).first) );
+      DistanceList.insert( pair<double, BoundaryTriangleSet *> (Point.distance(*(*runner).second), (*runner).first) );
 
   //for (DistanceTriangleMap::const_iterator runner = DistanceList.begin(); runner != DistanceList.end(); runner++)
Index: src/triangleintersectionlist.hpp
===================================================================
--- src/triangleintersectionlist.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/triangleintersectionlist.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -39,5 +39,5 @@
 {
 public:
-  TriangleIntersectionList(const Vector *x, const Tesselation *surface, const LinkedCell* LC);
+  TriangleIntersectionList(const Vector &x, const Tesselation *surface, const LinkedCell* LC);
   ~TriangleIntersectionList();
 
@@ -52,5 +52,5 @@
   void FillDistanceList() const;
 
-  const Vector *Point;
+  const Vector &Point;
   const Tesselation *Tess;
   const LinkedCell *Vicinity;
Index: src/unittests/ActOnAllUnitTest.cpp
===================================================================
--- src/unittests/ActOnAllUnitTest.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/unittests/ActOnAllUnitTest.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ActOnAllUnitTest.cpp
@@ -5,4 +12,9 @@
  *      Author: FrederikHeber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -14,5 +26,5 @@
 #include "../test/ActOnAlltest.hpp"
 #include "ActOnAllUnitTest.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 #ifdef HAVE_TESTRUNNER
Index: src/unittests/ActionSequenceTest.cpp
===================================================================
--- src/unittests/ActionSequenceTest.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/unittests/ActionSequenceTest.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ActionSequenzTest.cpp
@@ -6,4 +13,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include <cppunit/CompilerOutputter.h>
 #include <cppunit/extensions/TestFactoryRegistry.h>
@@ -35,4 +47,7 @@
   virtual ~canUndoActionStub(){}
 
+  virtual void getParametersfromValueStorage(){
+  }
+
   virtual Dialog* fillDialog(Dialog *dialog){
     ASSERT(dialog,"No Dialog given when filling action dialog");
@@ -62,4 +77,7 @@
   cannotUndoActionStub() : Action("cannotUndoActionStub",false){}
   virtual ~cannotUndoActionStub(){}
+
+  virtual void getParametersfromValueStorage(){
+  }
 
   virtual Dialog* fillDialog(Dialog *dialog){
@@ -93,4 +111,7 @@
   {}
   virtual ~wasCalledActionStub(){}
+
+  virtual void getParametersfromValueStorage(){
+  }
 
   virtual Dialog* fillDialog(Dialog *dialog){
@@ -243,12 +264,12 @@
 
   CPPUNIT_ASSERT_EQUAL(true,wasCalled1->wasCalled());
-  CPPUNIT_ASSERT_EQUAL(true,wasCalled1->wasCalled());
+  CPPUNIT_ASSERT_EQUAL(true,wasCalled2->wasCalled());
 
   ActionHistory::getInstance().undoLast();
 
   CPPUNIT_ASSERT_EQUAL(false,wasCalled1->wasCalled());
-  CPPUNIT_ASSERT_EQUAL(false,wasCalled1->wasCalled());
-
-}
-
-
+  CPPUNIT_ASSERT_EQUAL(false,wasCalled2->wasCalled());
+
+}
+
+
Index: src/unittests/AnalysisCorrelationToPointUnitTest.cpp
===================================================================
--- src/unittests/AnalysisCorrelationToPointUnitTest.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/unittests/AnalysisCorrelationToPointUnitTest.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * AnalysisCorrelationToPointUnitTest.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -46,5 +58,5 @@
 
   // construct element list
-  std::vector<element *> elements;
+  std::vector<const element *> elements;
   hydrogen = World::getInstance().getPeriode()->FindElement(1);
   CPPUNIT_ASSERT(hydrogen != NULL && "hydrogen element not found");
@@ -53,18 +65,18 @@
   TestMolecule = World::getInstance().createMolecule();
   Walker = World::getInstance().createAtom();
-  Walker->type = hydrogen;
-  *Walker->node = Vector(1., 0., 1. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(1., 0., 1. ));
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
-  Walker->type = hydrogen;
-  *Walker->node = Vector(0., 1., 1. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(0., 1., 1. ));
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
-  Walker->type = hydrogen;
-  *Walker->node = Vector(1., 1., 0. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(1., 1., 0. ));
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
-  Walker->type = hydrogen;
-  *Walker->node = Vector(0., 0., 0. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(0., 0., 0. ));
   TestMolecule->AddAtom(Walker);
 
Index: src/unittests/AnalysisCorrelationToPointUnitTest.hpp
===================================================================
--- src/unittests/AnalysisCorrelationToPointUnitTest.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/unittests/AnalysisCorrelationToPointUnitTest.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -37,5 +37,5 @@
       std::vector<molecule *> allMolecules;
       molecule *TestMolecule;
-      element *hydrogen;
+      const element *hydrogen;
 
       CorrelationToPointMap *pointmap;
Index: src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp
===================================================================
--- src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * AnalysisCorrelationToSurfaceUnitTest.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -44,4 +56,6 @@
   ASSERT_DO(Assert::Throw);
 
+  setVerbosity(5);
+
   atom *Walker = NULL;
 
@@ -62,21 +76,21 @@
 
   Walker = World::getInstance().createAtom();
-  Walker->type = hydrogen;
-  *Walker->node = Vector(1., 0., 1. );
-  TestSurfaceMolecule->AddAtom(Walker);
-
-  Walker = World::getInstance().createAtom();
-  Walker->type = hydrogen;
-  *Walker->node = Vector(0., 1., 1. );
-  TestSurfaceMolecule->AddAtom(Walker);
-
-  Walker = World::getInstance().createAtom();
-  Walker->type = hydrogen;
-  *Walker->node = Vector(1., 1., 0. );
-  TestSurfaceMolecule->AddAtom(Walker);
-
-  Walker = World::getInstance().createAtom();
-  Walker->type = hydrogen;
-  *Walker->node = Vector(0., 0., 0. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(1., 0., 1. ));
+  TestSurfaceMolecule->AddAtom(Walker);
+
+  Walker = World::getInstance().createAtom();
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(0., 1., 1. ));
+  TestSurfaceMolecule->AddAtom(Walker);
+
+  Walker = World::getInstance().createAtom();
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(1., 1., 0. ));
+  TestSurfaceMolecule->AddAtom(Walker);
+
+  Walker = World::getInstance().createAtom();
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(0., 0., 0. ));
   TestSurfaceMolecule->AddAtom(Walker);
 
@@ -88,5 +102,5 @@
   // init tesselation and linked cell
   Surface = new Tesselation;
-  LC = new LinkedCell(TestSurfaceMolecule, 5.);
+  LC = new LinkedCell(*TestSurfaceMolecule, 5.);
   FindNonConvexBorder(TestSurfaceMolecule, Surface, (const LinkedCell *&)LC, 2.5, NULL);
 
@@ -95,22 +109,22 @@
   TestSurfaceMolecule = World::getInstance().createMolecule();
   Walker = World::getInstance().createAtom();
-  Walker->type = carbon;
-  *Walker->node = Vector(4., 0., 4. );
-  TestSurfaceMolecule->AddAtom(Walker);
-
-  Walker = World::getInstance().createAtom();
-  Walker->type = carbon;
-  *Walker->node = Vector(0., 4., 4. );
-  TestSurfaceMolecule->AddAtom(Walker);
-
-  Walker = World::getInstance().createAtom();
-  Walker->type = carbon;
-  *Walker->node = Vector(4., 4., 0. );
+  Walker->setType(carbon);
+  Walker->setPosition(Vector(4., 0., 4. ));
+  TestSurfaceMolecule->AddAtom(Walker);
+
+  Walker = World::getInstance().createAtom();
+  Walker->setType(carbon);
+  Walker->setPosition(Vector(0., 4., 4. ));
+  TestSurfaceMolecule->AddAtom(Walker);
+
+  Walker = World::getInstance().createAtom();
+  Walker->setType(carbon);
+  Walker->setPosition(Vector(4., 4., 0. ));
   TestSurfaceMolecule->AddAtom(Walker);
 
   // add inner atoms
   Walker = World::getInstance().createAtom();
-  Walker->type = carbon;
-  *Walker->node = Vector(0.5, 0.5, 0.5 );
+  Walker->setType(carbon);
+  Walker->setPosition(Vector(0.5, 0.5, 0.5 ));
   TestSurfaceMolecule->AddAtom(Walker);
 
Index: src/unittests/AnalysisCorrelationToSurfaceUnitTest.hpp
===================================================================
--- src/unittests/AnalysisCorrelationToSurfaceUnitTest.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/unittests/AnalysisCorrelationToSurfaceUnitTest.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -45,7 +45,7 @@
       std::vector<molecule *> allMolecules;
       molecule *TestSurfaceMolecule;
-      element *hydrogen;
-      element *carbon;
-      std::vector<element *> elements;
+      const element *hydrogen;
+      const element *carbon;
+      std::vector<const element *> elements;
 
       CorrelationToSurfaceMap *surfacemap;
Index: src/unittests/AnalysisPairCorrelationUnitTest.cpp
===================================================================
--- src/unittests/AnalysisPairCorrelationUnitTest.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/unittests/AnalysisPairCorrelationUnitTest.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * AnalysisPairCorrelationUnitTest.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -49,5 +61,5 @@
 
   // construct element list
-  std::vector<element *> elements;
+  std::vector<const element *> elements;
   hydrogen = World::getInstance().getPeriode()->FindElement(1);
   CPPUNIT_ASSERT(hydrogen != NULL && "hydrogen element not found");
@@ -58,18 +70,18 @@
   TestMolecule = World::getInstance().createMolecule();
   Walker = World::getInstance().createAtom();
-  Walker->type = hydrogen;
-  *Walker->node = Vector(1., 0., 1. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(1., 0., 1. ));
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
-  Walker->type = hydrogen;
-  *Walker->node = Vector(0., 1., 1. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(0., 1., 1. ));
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
-  Walker->type = hydrogen;
-  *Walker->node = Vector(1., 1., 0. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(1., 1., 0. ));
   TestMolecule->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
-  Walker->type = hydrogen;
-  *Walker->node = Vector(0., 0., 0. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(0., 0., 0. ));
   TestMolecule->AddAtom(Walker);
 
Index: src/unittests/AnalysisPairCorrelationUnitTest.hpp
===================================================================
--- src/unittests/AnalysisPairCorrelationUnitTest.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/unittests/AnalysisPairCorrelationUnitTest.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -37,5 +37,5 @@
       std::vector<molecule *> allMolecules;
       molecule *TestMolecule;
-      element *hydrogen;
+      const element *hydrogen;
 
       PairCorrelationMap *correlationmap;
